// $ANTLR 3.2 Sep 23, 2009 14:05:07 org/objectweb/fractal/fscript/parser/FScript.g 2010-07-23 19:17:35

/*
 * Copyright (c) 2007-2008 ARMINES
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 */
package org.objectweb.fractal.fscript.parser;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import com.google.common.base.Preconditions;

import org.antlr.runtime.Token;

import org.objectweb.fractal.fscript.ast.*;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class FScriptParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "LETTER", "DIGIT", "ID", "NUMBER", "DQ_STRING", "SQ_STRING", "STRING", "ESC", "WS", "SL_COMMENT", "'function'", "'action'", "'('", "')'", "','", "'{'", "'}'", "'var'", "'='", "';'", "'return'", "'if'", "'else'", "'for'", "':'", "'||'", "'&&'", "'=='", "'!='", "'<'", "'<='", "'>'", "'>='", "'+'", "'-'", "'*'", "'div'", "'|'", "'&'", "'\\\\'", "'/'", "'$'", "'::'", "'@'", "'..'", "'['", "']'", "'.'"
    };
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int LETTER=4;
    public static final int ESC=11;
    public static final int T__22=22;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int ID=6;
    public static final int EOF=-1;
    public static final int DQ_STRING=8;
    public static final int T__19=19;
    public static final int T__16=16;
    public static final int T__51=51;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__14=14;
    public static final int DIGIT=5;
    public static final int T__50=50;
    public static final int T__42=42;
    public static final int T__43=43;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int NUMBER=7;
    public static final int SQ_STRING=9;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int WS=12;
    public static final int T__33=33;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int SL_COMMENT=13;
    public static final int STRING=10;

    // delegates
    // delegators


        public FScriptParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public FScriptParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return FScriptParser.tokenNames; }
    public String getGrammarFileName() { return "org/objectweb/fractal/fscript/parser/FScript.g"; }


        private Object sourceDocument = null;

        /**
         * This method should be called before starting the parsing.
         */
        public void setSourceDocument(Object doc) {
            this.sourceDocument = doc;
        }

        /**
         * Interprets a string litteral found in FScript source code as a
         * Java <code>String</code> value.
         */
        private String stringValue(String litteral) {
            // Remove enclosing quotes.
            String str = litteral.substring(1, litteral.length() - 1);
            // Replace quoted chars with their actual values. We need two
            // quoting levels for backslashes in the first argument: one
            // for standard Java strings, and one because this parameter
            // is interpreted as a regexp.
            str = str.replaceAll("\\\\n", "\n");
            str = str.replaceAll("\\\\r", "\r");
            str = str.replaceAll("\\\\t", "\t");
            str = str.replaceAll("\\\\'", "'");
            str = str.replaceAll("\\\\\"", "\"");
            return str;
        }

        // These helper functions are used to create appropriate SourceLocation objects from
        // the raw information obtained from ANTLR and lower-level rules results.

        private SourceLocation sourceExtent(Token tok) {
            Preconditions.checkNotNull(tok);
            final int line = tok.getLine();
            final int startCol  = tok.getCharPositionInLine() + 1;
            final int endCol = startCol + tok.getText().length();
            return new SourceLocation(sourceDocument, line, startCol, line, endCol);
        }

        private SourceLocation sourceExtent(Token first, Token last) {
            Preconditions.checkNotNull(first);
            Preconditions.checkNotNull(last);
            return sourceExtent(sourceExtent(first), sourceExtent(last));
        }

        private SourceLocation sourceExtent(ASTNode first, ASTNode last) {
            Preconditions.checkNotNull(first);
            if (last != null) {
                return sourceExtent(first.getSourceLocation(), last.getSourceLocation());
            } else {
                return first.getSourceLocation();
            }
        }

        private SourceLocation sourceExtent(List<ASTNode> nodes) {
            Preconditions.checkNotNull(nodes);
            Preconditions.checkArgument(!nodes.isEmpty());
            Preconditions.checkContentsNotNull(nodes);
            return sourceExtent(nodes.get(0), nodes.get(nodes.size() - 1));
        }

        private SourceLocation sourceExtent(SourceLocation first, SourceLocation last) {
            Preconditions.checkNotNull(first);
            Preconditions.checkNotNull(last);
            Preconditions.checkArgument(first.getSourceDocument() == last.getSourceDocument(),
                    "Incompatible bounds: not from the same document.");
            return new SourceLocation(first.getSourceDocument(), first.getStartLine(), first
                    .getStartColumn(), last.getEndLine(), last.getEndColumn());
        }

        protected void mismatch(IntStream input, int ttype, BitSet follow) throws RecognitionException {
            throw new MismatchedTokenException(ttype, input);
        }

        protected void recoverFromMismatch(IntStream input, RecognitionException e, BitSet follow)
            throws RecognitionException {
            throw e;
        }
        
        public void emitErrorMessage(String msg) {
    		//Do nothing
    	}



    // $ANTLR start "definitions"
    // org/objectweb/fractal/fscript/parser/FScript.g:250:1: definitions returns [ List<UserProcedure> result ] : (def= definition )+ ;
    public final List<UserProcedure> definitions() throws RecognitionException {
        List<UserProcedure> result = null;

        UserProcedure def = null;



          result = new ArrayList<UserProcedure>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:257:5: ( (def= definition )+ )
            // org/objectweb/fractal/fscript/parser/FScript.g:257:9: (def= definition )+
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:257:9: (def= definition )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                switch ( input.LA(1) ) {
                case 14:
                case 15:
                    {
                    alt1=1;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:257:11: def= definition
            	    {
            	    pushFollow(FOLLOW_definition_in_definitions530);
            	    def=definition();

            	    state._fsp--;

            	     result.add(def); 

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "definitions"


    // $ANTLR start "definition"
    // org/objectweb/fractal/fscript/parser/FScript.g:260:1: definition returns [ UserProcedure result ] : (k= 'function' | k= 'action' ) name= ID '(' params= parameters ')' body= block ;
    public final UserProcedure definition() throws RecognitionException {
        UserProcedure result = null;

        Token k=null;
        Token name=null;
        List<String> params = null;

        ASTNode body = null;



          boolean pure = false;

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:271:5: ( (k= 'function' | k= 'action' ) name= ID '(' params= parameters ')' body= block )
            // org/objectweb/fractal/fscript/parser/FScript.g:272:5: (k= 'function' | k= 'action' ) name= ID '(' params= parameters ')' body= block
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:272:5: (k= 'function' | k= 'action' )
            int alt2=2;
            switch ( input.LA(1) ) {
            case 14:
                {
                alt2=1;
                }
                break;
            case 15:
                {
                alt2=2;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:272:6: k= 'function'
                    {
                    k=(Token)match(input,14,FOLLOW_14_in_definition575); 
                     pure = true; 

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:272:38: k= 'action'
                    {
                    k=(Token)match(input,15,FOLLOW_15_in_definition583); 

                    }
                    break;

            }

            name=(Token)match(input,ID,FOLLOW_ID_in_definition588); 
            match(input,16,FOLLOW_16_in_definition590); 
            pushFollow(FOLLOW_parameters_in_definition594);
            params=parameters();

            state._fsp--;

            match(input,17,FOLLOW_17_in_definition596); 
            pushFollow(FOLLOW_block_in_definition600);
            body=block();

            state._fsp--;


            }


              SourceLocation loc = sourceExtent(sourceExtent(k), body.getSourceLocation());
              result = new UserProcedure(loc, pure, (name!=null?name.getText():null), params, body);

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "definition"


    // $ANTLR start "parameters"
    // org/objectweb/fractal/fscript/parser/FScript.g:275:1: parameters returns [ List<String> result ] : (id1= ID ( ',' id2= ID )* )? ;
    public final List<String> parameters() throws RecognitionException {
        List<String> result = null;

        Token id1=null;
        Token id2=null;


          result = new ArrayList<String>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:282:5: ( (id1= ID ( ',' id2= ID )* )? )
            // org/objectweb/fractal/fscript/parser/FScript.g:282:9: (id1= ID ( ',' id2= ID )* )?
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:282:9: (id1= ID ( ',' id2= ID )* )?
            int alt4=2;
            switch ( input.LA(1) ) {
                case ID:
                    {
                    alt4=1;
                    }
                    break;
            }

            switch (alt4) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:282:11: id1= ID ( ',' id2= ID )*
                    {
                    id1=(Token)match(input,ID,FOLLOW_ID_in_parameters634); 
                     result.add((id1!=null?id1.getText():null)); 
                    // org/objectweb/fractal/fscript/parser/FScript.g:282:45: ( ',' id2= ID )*
                    loop3:
                    do {
                        int alt3=2;
                        switch ( input.LA(1) ) {
                        case 18:
                            {
                            alt3=1;
                            }
                            break;

                        }

                        switch (alt3) {
                    	case 1 :
                    	    // org/objectweb/fractal/fscript/parser/FScript.g:282:46: ',' id2= ID
                    	    {
                    	    match(input,18,FOLLOW_18_in_parameters639); 
                    	    id2=(Token)match(input,ID,FOLLOW_ID_in_parameters643); 
                    	     result.add((id2!=null?id2.getText():null)); 

                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);


                    }
                    break;

            }


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "parameters"


    // $ANTLR start "block"
    // org/objectweb/fractal/fscript/parser/FScript.g:285:1: block returns [ ASTNode result ] : open= '{' (step= statement )+ close= '}' ;
    public final ASTNode block() throws RecognitionException {
        ASTNode result = null;

        Token open=null;
        Token close=null;
        ASTNode step = null;



          List<ASTNode> steps = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:296:5: (open= '{' (step= statement )+ close= '}' )
            // org/objectweb/fractal/fscript/parser/FScript.g:296:9: open= '{' (step= statement )+ close= '}'
            {
            open=(Token)match(input,19,FOLLOW_19_in_block688); 
            // org/objectweb/fractal/fscript/parser/FScript.g:296:18: (step= statement )+
            int cnt5=0;
            loop5:
            do {
                int alt5=2;
                switch ( input.LA(1) ) {
                case ID:
                case NUMBER:
                case STRING:
                case 16:
                case 21:
                case 24:
                case 25:
                case 27:
                case 38:
                case 45:
                case 51:
                    {
                    alt5=1;
                    }
                    break;

                }

                switch (alt5) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:296:20: step= statement
            	    {
            	    pushFollow(FOLLOW_statement_in_block694);
            	    step=statement();

            	    state._fsp--;

            	     steps.add(step); 

            	    }
            	    break;

            	default :
            	    if ( cnt5 >= 1 ) break loop5;
                        EarlyExitException eee =
                            new EarlyExitException(5, input);
                        throw eee;
                }
                cnt5++;
            } while (true);

            close=(Token)match(input,20,FOLLOW_20_in_block703); 

            }


              final SourceLocation loc = sourceExtent(open, close);
              result = new Block(loc, steps);

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "block"


    // $ANTLR start "statement"
    // org/objectweb/fractal/fscript/parser/FScript.g:299:1: statement returns [ ASTNode result ] : (s= 'var' ID '=' v= expression e= ';' | ID '=' v= expression e= ';' | stat= expression ';' | s= 'return' (v= expression )? e= ';' | s= 'if' '(' cond= expression ')' trueBranch= block ( 'else' falseBranch= block )? | s= 'for' ID ':' values= expression body= block );
    public final ASTNode statement() throws RecognitionException {
        ASTNode result = null;

        Token s=null;
        Token e=null;
        Token ID1=null;
        Token ID2=null;
        Token ID3=null;
        ASTNode v = null;

        ASTNode stat = null;

        ASTNode cond = null;

        ASTNode trueBranch = null;

        ASTNode falseBranch = null;

        ASTNode values = null;

        ASTNode body = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:303:5: (s= 'var' ID '=' v= expression e= ';' | ID '=' v= expression e= ';' | stat= expression ';' | s= 'return' (v= expression )? e= ';' | s= 'if' '(' cond= expression ')' trueBranch= block ( 'else' falseBranch= block )? | s= 'for' ID ':' values= expression body= block )
            int alt8=6;
            switch ( input.LA(1) ) {
            case 21:
                {
                alt8=1;
                }
                break;
            case ID:
                {
                switch ( input.LA(2) ) {
                case 22:
                    {
                    alt8=2;
                    }
                    break;
                case 16:
                    {
                    alt8=3;
                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 2, input);

                    throw nvae;
                }

                }
                break;
            case NUMBER:
            case STRING:
            case 16:
            case 38:
            case 45:
            case 51:
                {
                alt8=3;
                }
                break;
            case 24:
                {
                alt8=4;
                }
                break;
            case 25:
                {
                alt8=5;
                }
                break;
            case 27:
                {
                alt8=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:305:8: s= 'var' ID '=' v= expression e= ';'
                    {
                    s=(Token)match(input,21,FOLLOW_21_in_statement744); 
                    ID1=(Token)match(input,ID,FOLLOW_ID_in_statement746); 
                    match(input,22,FOLLOW_22_in_statement748); 
                    pushFollow(FOLLOW_expression_in_statement752);
                    v=expression();

                    state._fsp--;

                    e=(Token)match(input,23,FOLLOW_23_in_statement756); 

                                final SourceLocation loc = sourceExtent(s, e);
                                result = new Assignment(loc, true, (ID1!=null?ID1.getText():null), v);
                            

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:312:9: ID '=' v= expression e= ';'
                    {
                    ID2=(Token)match(input,ID,FOLLOW_ID_in_statement786); 
                    match(input,22,FOLLOW_22_in_statement788); 
                    pushFollow(FOLLOW_expression_in_statement792);
                    v=expression();

                    state._fsp--;

                    e=(Token)match(input,23,FOLLOW_23_in_statement796); 

                                final SourceLocation loc = sourceExtent(ID2, e);
                                result = new Assignment(loc, false, (ID2!=null?ID2.getText():null), v);
                            

                    }
                    break;
                case 3 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:319:9: stat= expression ';'
                    {
                    pushFollow(FOLLOW_expression_in_statement828);
                    stat=expression();

                    state._fsp--;

                    match(input,23,FOLLOW_23_in_statement830); 

                                result = stat;
                            

                    }
                    break;
                case 4 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:325:9: s= 'return' (v= expression )? e= ';'
                    {
                    s=(Token)match(input,24,FOLLOW_24_in_statement862); 
                    // org/objectweb/fractal/fscript/parser/FScript.g:325:21: (v= expression )?
                    int alt6=2;
                    switch ( input.LA(1) ) {
                        case ID:
                        case NUMBER:
                        case STRING:
                        case 16:
                        case 38:
                        case 45:
                        case 51:
                            {
                            alt6=1;
                            }
                            break;
                    }

                    switch (alt6) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:325:21: v= expression
                            {
                            pushFollow(FOLLOW_expression_in_statement866);
                            v=expression();

                            state._fsp--;


                            }
                            break;

                    }

                    e=(Token)match(input,23,FOLLOW_23_in_statement871); 

                                final SourceLocation loc = sourceExtent(s, e);
                                result = new ExplicitReturn(loc, v);
                            

                    }
                    break;
                case 5 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:332:9: s= 'if' '(' cond= expression ')' trueBranch= block ( 'else' falseBranch= block )?
                    {
                    s=(Token)match(input,25,FOLLOW_25_in_statement903); 
                    match(input,16,FOLLOW_16_in_statement905); 
                    pushFollow(FOLLOW_expression_in_statement909);
                    cond=expression();

                    state._fsp--;

                    match(input,17,FOLLOW_17_in_statement911); 
                    pushFollow(FOLLOW_block_in_statement915);
                    trueBranch=block();

                    state._fsp--;

                    // org/objectweb/fractal/fscript/parser/FScript.g:332:57: ( 'else' falseBranch= block )?
                    int alt7=2;
                    switch ( input.LA(1) ) {
                        case 26:
                            {
                            alt7=1;
                            }
                            break;
                    }

                    switch (alt7) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:332:58: 'else' falseBranch= block
                            {
                            match(input,26,FOLLOW_26_in_statement918); 
                            pushFollow(FOLLOW_block_in_statement922);
                            falseBranch=block();

                            state._fsp--;


                            }
                            break;

                    }


                                final ASTNode endNode = (falseBranch != null) ? falseBranch : trueBranch;
                                final SourceLocation loc = sourceExtent(sourceExtent(s), endNode.getSourceLocation());
                                result = new Conditional(loc, cond, trueBranch, falseBranch);
                            

                    }
                    break;
                case 6 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:340:9: s= 'for' ID ':' values= expression body= block
                    {
                    s=(Token)match(input,27,FOLLOW_27_in_statement956); 
                    ID3=(Token)match(input,ID,FOLLOW_ID_in_statement958); 
                    match(input,28,FOLLOW_28_in_statement960); 
                    pushFollow(FOLLOW_expression_in_statement964);
                    values=expression();

                    state._fsp--;

                    pushFollow(FOLLOW_block_in_statement968);
                    body=block();

                    state._fsp--;


                                final SourceLocation loc = sourceExtent(sourceExtent(s), body.getSourceLocation());
                                result = new Loop(loc, (ID3!=null?ID3.getText():null), values, body);
                            

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "statement"


    // $ANTLR start "expression"
    // org/objectweb/fractal/fscript/parser/FScript.g:347:1: expression returns [ ASTNode result ] : e= orExpression ;
    public final ASTNode expression() throws RecognitionException {
        ASTNode result = null;

        ASTNode e = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:353:5: (e= orExpression )
            // org/objectweb/fractal/fscript/parser/FScript.g:353:9: e= orExpression
            {
            pushFollow(FOLLOW_orExpression_in_expression1005);
            e=orExpression();

            state._fsp--;

             result = e; 

            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "expression"


    // $ANTLR start "orExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:356:1: orExpression returns [ ASTNode result ] : e1= andExpression ( '||' e2= andExpression )* ;
    public final ASTNode orExpression() throws RecognitionException {
        ASTNode result = null;

        ASTNode e1 = null;

        ASTNode e2 = null;



          List<ASTNode> clauses = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:370:5: (e1= andExpression ( '||' e2= andExpression )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:370:12: e1= andExpression ( '||' e2= andExpression )*
            {
            pushFollow(FOLLOW_andExpression_in_orExpression1047);
            e1=andExpression();

            state._fsp--;

             clauses.add(e1); 
            // org/objectweb/fractal/fscript/parser/FScript.g:371:5: ( '||' e2= andExpression )*
            loop9:
            do {
                int alt9=2;
                switch ( input.LA(1) ) {
                case 29:
                    {
                    alt9=1;
                    }
                    break;

                }

                switch (alt9) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:371:7: '||' e2= andExpression
            	    {
            	    match(input,29,FOLLOW_29_in_orExpression1057); 
            	    pushFollow(FOLLOW_andExpression_in_orExpression1061);
            	    e2=andExpression();

            	    state._fsp--;

            	     clauses.add(e2); 

            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);


            }


              if (clauses.size() == 1) {
                result = clauses.get(0);
              } else {
                result = new Disjunction(sourceExtent(clauses), clauses);
              }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "orExpression"


    // $ANTLR start "andExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:374:1: andExpression returns [ ASTNode result ] : e1= compExpression ( '&&' e2= compExpression )* ;
    public final ASTNode andExpression() throws RecognitionException {
        ASTNode result = null;

        ASTNode e1 = null;

        ASTNode e2 = null;



          List<ASTNode> clauses = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:388:5: (e1= compExpression ( '&&' e2= compExpression )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:388:12: e1= compExpression ( '&&' e2= compExpression )*
            {
            pushFollow(FOLLOW_compExpression_in_andExpression1106);
            e1=compExpression();

            state._fsp--;

             clauses.add(e1); 
            // org/objectweb/fractal/fscript/parser/FScript.g:389:5: ( '&&' e2= compExpression )*
            loop10:
            do {
                int alt10=2;
                switch ( input.LA(1) ) {
                case 30:
                    {
                    alt10=1;
                    }
                    break;

                }

                switch (alt10) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:389:7: '&&' e2= compExpression
            	    {
            	    match(input,30,FOLLOW_30_in_andExpression1116); 
            	    pushFollow(FOLLOW_compExpression_in_andExpression1120);
            	    e2=compExpression();

            	    state._fsp--;

            	     clauses.add(e2); 

            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);


            }


              if (clauses.size() == 1) {
                result = clauses.get(0);
              } else {
                result = new Conjunction(sourceExtent(clauses), clauses);
              }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "andExpression"


    // $ANTLR start "compExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:392:1: compExpression returns [ ASTNode result ] : e1= addExpression (op= ( '==' | '!=' | '<' | '<=' | '>' | '>=' ) e2= addExpression )? ;
    public final ASTNode compExpression() throws RecognitionException {
        ASTNode result = null;

        Token op=null;
        ASTNode e1 = null;

        ASTNode e2 = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:404:5: (e1= addExpression (op= ( '==' | '!=' | '<' | '<=' | '>' | '>=' ) e2= addExpression )? )
            // org/objectweb/fractal/fscript/parser/FScript.g:404:9: e1= addExpression (op= ( '==' | '!=' | '<' | '<=' | '>' | '>=' ) e2= addExpression )?
            {
            pushFollow(FOLLOW_addExpression_in_compExpression1157);
            e1=addExpression();

            state._fsp--;

            // org/objectweb/fractal/fscript/parser/FScript.g:404:26: (op= ( '==' | '!=' | '<' | '<=' | '>' | '>=' ) e2= addExpression )?
            int alt11=2;
            switch ( input.LA(1) ) {
                case 31:
                case 32:
                case 33:
                case 34:
                case 35:
                case 36:
                    {
                    alt11=1;
                    }
                    break;
            }

            switch (alt11) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:404:28: op= ( '==' | '!=' | '<' | '<=' | '>' | '>=' ) e2= addExpression
                    {
                    op=(Token)input.LT(1);
                    if ( (input.LA(1)>=31 && input.LA(1)<=36) ) {
                        input.consume();
                        state.errorRecovery=false;
                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }

                    pushFollow(FOLLOW_addExpression_in_compExpression1179);
                    e2=addExpression();

                    state._fsp--;


                    }
                    break;

            }


            }


              if (e2 == null) {
                result = e1;
              } else {
                final SourceLocation loc = sourceExtent(e1, e2);
                result = new Call(loc, (op!=null?op.getText():null), Arrays.asList(e1, e2));
              }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "compExpression"


    // $ANTLR start "addExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:407:1: addExpression returns [ ASTNode result ] : e1= multExpression (op= ( '+' | '-' ) e2= multExpression )* ;
    public final ASTNode addExpression() throws RecognitionException {
        ASTNode result = null;

        Token op=null;
        ASTNode e1 = null;

        ASTNode e2 = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:411:5: (e1= multExpression (op= ( '+' | '-' ) e2= multExpression )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:411:20: e1= multExpression (op= ( '+' | '-' ) e2= multExpression )*
            {
            pushFollow(FOLLOW_multExpression_in_addExpression1220);
            e1=multExpression();

            state._fsp--;

             result = e1; 
            // org/objectweb/fractal/fscript/parser/FScript.g:412:5: (op= ( '+' | '-' ) e2= multExpression )*
            loop12:
            do {
                int alt12=2;
                switch ( input.LA(1) ) {
                case 37:
                case 38:
                    {
                    alt12=1;
                    }
                    break;

                }

                switch (alt12) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:412:7: op= ( '+' | '-' ) e2= multExpression
            	    {
            	    op=(Token)input.LT(1);
            	    if ( (input.LA(1)>=37 && input.LA(1)<=38) ) {
            	        input.consume();
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_multExpression_in_addExpression1240);
            	    e2=multExpression();

            	    state._fsp--;


            	            final SourceLocation loc = sourceExtent(result.getSourceLocation(), e2.getSourceLocation());
            	            result = new Call(loc, (op!=null?op.getText():null), Arrays.asList(result, e2));
            	        

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "addExpression"


    // $ANTLR start "multExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:420:1: multExpression returns [ ASTNode result ] : e1= unaryExpression (op= ( '*' | 'div' ) e2= unaryExpression )* ;
    public final ASTNode multExpression() throws RecognitionException {
        ASTNode result = null;

        Token op=null;
        ASTNode e1 = null;

        ASTNode e2 = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:424:5: (e1= unaryExpression (op= ( '*' | 'div' ) e2= unaryExpression )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:424:9: e1= unaryExpression (op= ( '*' | 'div' ) e2= unaryExpression )*
            {
            pushFollow(FOLLOW_unaryExpression_in_multExpression1280);
            e1=unaryExpression();

            state._fsp--;

             result = e1; 
            // org/objectweb/fractal/fscript/parser/FScript.g:425:5: (op= ( '*' | 'div' ) e2= unaryExpression )*
            loop13:
            do {
                int alt13=2;
                switch ( input.LA(1) ) {
                case 39:
                case 40:
                    {
                    alt13=1;
                    }
                    break;

                }

                switch (alt13) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:425:7: op= ( '*' | 'div' ) e2= unaryExpression
            	    {
            	    op=(Token)input.LT(1);
            	    if ( (input.LA(1)>=39 && input.LA(1)<=40) ) {
            	        input.consume();
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    pushFollow(FOLLOW_unaryExpression_in_multExpression1300);
            	    e2=unaryExpression();

            	    state._fsp--;


            	            final SourceLocation loc = sourceExtent(result.getSourceLocation(), e2.getSourceLocation());
            	            result = new Call(loc, (op!=null?op.getText():null), Arrays.asList(result, e2));
            	        

            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "multExpression"


    // $ANTLR start "unaryExpression"
    // org/objectweb/fractal/fscript/parser/FScript.g:433:1: unaryExpression returns [ ASTNode result ] : (s= '-' a= atom | a1= atom (op= ( '|' | '&' | '\\\\' ) a2= atom )? );
    public final ASTNode unaryExpression() throws RecognitionException {
        ASTNode result = null;

        Token s=null;
        Token op=null;
        ASTNode a = null;

        ASTNode a1 = null;

        ASTNode a2 = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:437:5: (s= '-' a= atom | a1= atom (op= ( '|' | '&' | '\\\\' ) a2= atom )? )
            int alt15=2;
            switch ( input.LA(1) ) {
            case 38:
                {
                alt15=1;
                }
                break;
            case ID:
            case NUMBER:
            case STRING:
            case 16:
            case 45:
            case 51:
                {
                alt15=2;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;
            }

            switch (alt15) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:437:9: s= '-' a= atom
                    {
                    s=(Token)match(input,38,FOLLOW_38_in_unaryExpression1340); 
                    pushFollow(FOLLOW_atom_in_unaryExpression1344);
                    a=atom();

                    state._fsp--;


                                final SourceLocation loc = sourceExtent(sourceExtent(s), a.getSourceLocation());
                                result = new Call(loc, "minus", Arrays.asList(a));
                            

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:442:9: a1= atom (op= ( '|' | '&' | '\\\\' ) a2= atom )?
                    {
                    pushFollow(FOLLOW_atom_in_unaryExpression1366);
                    a1=atom();

                    state._fsp--;

                    // org/objectweb/fractal/fscript/parser/FScript.g:442:17: (op= ( '|' | '&' | '\\\\' ) a2= atom )?
                    int alt14=2;
                    switch ( input.LA(1) ) {
                        case 41:
                        case 42:
                        case 43:
                            {
                            alt14=1;
                            }
                            break;
                    }

                    switch (alt14) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:442:19: op= ( '|' | '&' | '\\\\' ) a2= atom
                            {
                            op=(Token)input.LT(1);
                            if ( (input.LA(1)>=41 && input.LA(1)<=43) ) {
                                input.consume();
                                state.errorRecovery=false;
                            }
                            else {
                                MismatchedSetException mse = new MismatchedSetException(null,input);
                                throw mse;
                            }

                            pushFollow(FOLLOW_atom_in_unaryExpression1382);
                            a2=atom();

                            state._fsp--;


                            }
                            break;

                    }


                                if (op == null) {
                                    result = a1;
                                } else {
                                    final SourceLocation loc = sourceExtent(a1.getSourceLocation(), a2.getSourceLocation());
                                    String func = null;
                                    if ((op!=null?op.getText():null).equals("|"))       { func = "union"; }
                                    else if ((op!=null?op.getText():null).equals("&"))  { func = "intersection"; }
                                    else if ((op!=null?op.getText():null).equals("\\")) { func = "difference"; }
                                    result = new Call(loc, func, a1, a2);
                                }
                            

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "unaryExpression"


    // $ANTLR start "atom"
    // org/objectweb/fractal/fscript/parser/FScript.g:457:1: atom returns [ ASTNode result ] : (l= literal | '(' expr= expression ')' | c= call ( '/' p= relativePath )? | v= variable ( '/' p= relativePath )? );
    public final ASTNode atom() throws RecognitionException {
        ASTNode result = null;

        ASTNode l = null;

        ASTNode expr = null;

        ASTNode c = null;

        List<ASTNode> p = null;

        ASTNode v = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:461:5: (l= literal | '(' expr= expression ')' | c= call ( '/' p= relativePath )? | v= variable ( '/' p= relativePath )? )
            int alt18=4;
            switch ( input.LA(1) ) {
            case NUMBER:
            case STRING:
                {
                alt18=1;
                }
                break;
            case 16:
                {
                alt18=2;
                }
                break;
            case ID:
            case 51:
                {
                alt18=3;
                }
                break;
            case 45:
                {
                alt18=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }

            switch (alt18) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:463:9: l= literal
                    {
                    pushFollow(FOLLOW_literal_in_atom1437);
                    l=literal();

                    state._fsp--;

                     result = l; 

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:466:9: '(' expr= expression ')'
                    {
                    match(input,16,FOLLOW_16_in_atom1459); 
                    pushFollow(FOLLOW_expression_in_atom1463);
                    expr=expression();

                    state._fsp--;

                    match(input,17,FOLLOW_17_in_atom1465); 
                     result = expr; 

                    }
                    break;
                case 3 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:469:9: c= call ( '/' p= relativePath )?
                    {
                    pushFollow(FOLLOW_call_in_atom1489);
                    c=call();

                    state._fsp--;

                    // org/objectweb/fractal/fscript/parser/FScript.g:469:16: ( '/' p= relativePath )?
                    int alt16=2;
                    switch ( input.LA(1) ) {
                        case 44:
                            {
                            alt16=1;
                            }
                            break;
                    }

                    switch (alt16) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:469:17: '/' p= relativePath
                            {
                            match(input,44,FOLLOW_44_in_atom1492); 
                            pushFollow(FOLLOW_relativePath_in_atom1496);
                            p=relativePath();

                            state._fsp--;


                            }
                            break;

                    }


                                if (p == null) {
                                    result = c;
                                } else {
                                    final SourceLocation loc = sourceExtent(c.getSourceLocation(), sourceExtent(p));
                                    result = new LocationPath(loc, c, p);
                                }
                            

                    }
                    break;
                case 4 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:480:9: v= variable ( '/' p= relativePath )?
                    {
                    pushFollow(FOLLOW_variable_in_atom1531);
                    v=variable();

                    state._fsp--;

                    // org/objectweb/fractal/fscript/parser/FScript.g:480:20: ( '/' p= relativePath )?
                    int alt17=2;
                    switch ( input.LA(1) ) {
                        case 44:
                            {
                            alt17=1;
                            }
                            break;
                    }

                    switch (alt17) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:480:21: '/' p= relativePath
                            {
                            match(input,44,FOLLOW_44_in_atom1534); 
                            pushFollow(FOLLOW_relativePath_in_atom1538);
                            p=relativePath();

                            state._fsp--;


                            }
                            break;

                    }


                                if (p == null) {
                                    result = v;
                                } else {
                                    final SourceLocation loc = sourceExtent(v.getSourceLocation(), sourceExtent(p));
                                    result = new LocationPath(loc, v, p);
                                }
                            

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "atom"


    // $ANTLR start "relativePath"
    // org/objectweb/fractal/fscript/parser/FScript.g:491:1: relativePath returns [ List<ASTNode> result ] : step1= locationStep ( '/' step2= locationStep )* ;
    public final List<ASTNode> relativePath() throws RecognitionException {
        List<ASTNode> result = null;

        ASTNode step1 = null;

        ASTNode step2 = null;



          result = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:498:5: (step1= locationStep ( '/' step2= locationStep )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:498:10: step1= locationStep ( '/' step2= locationStep )*
            {
            pushFollow(FOLLOW_locationStep_in_relativePath1584);
            step1=locationStep();

            state._fsp--;

             result.add(step1); 
            // org/objectweb/fractal/fscript/parser/FScript.g:499:5: ( '/' step2= locationStep )*
            loop19:
            do {
                int alt19=2;
                switch ( input.LA(1) ) {
                case 44:
                    {
                    alt19=1;
                    }
                    break;

                }

                switch (alt19) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:499:6: '/' step2= locationStep
            	    {
            	    match(input,44,FOLLOW_44_in_relativePath1593); 
            	    pushFollow(FOLLOW_locationStep_in_relativePath1597);
            	    step2=locationStep();

            	    state._fsp--;

            	     result.add(step2); 

            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "relativePath"


    // $ANTLR start "variable"
    // org/objectweb/fractal/fscript/parser/FScript.g:502:1: variable returns [ ASTNode result ] : s= '$' ID ;
    public final ASTNode variable() throws RecognitionException {
        ASTNode result = null;

        Token s=null;
        Token ID4=null;

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:506:5: (s= '$' ID )
            // org/objectweb/fractal/fscript/parser/FScript.g:506:9: s= '$' ID
            {
            s=(Token)match(input,45,FOLLOW_45_in_variable1629); 
            ID4=(Token)match(input,ID,FOLLOW_ID_in_variable1631); 
             result = new VariableReference(sourceExtent(s, ID4), (ID4!=null?ID4.getText():null)); 

            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "variable"


    // $ANTLR start "locationStep"
    // org/objectweb/fractal/fscript/parser/FScript.g:509:1: locationStep returns [ ASTNode result ] : ( ( ID '::' )? t= test p= predicates | a= '@' t= test p= predicates | a= '..' p= predicates | a= '/' t= test p= predicates );
    public final ASTNode locationStep() throws RecognitionException {
        ASTNode result = null;

        Token a=null;
        Token ID5=null;
        ASTNode t = null;

        List<ASTNode> p = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:513:5: ( ( ID '::' )? t= test p= predicates | a= '@' t= test p= predicates | a= '..' p= predicates | a= '/' t= test p= predicates )
            int alt21=4;
            switch ( input.LA(1) ) {
            case ID:
            case STRING:
            case 39:
            case 45:
                {
                alt21=1;
                }
                break;
            case 47:
                {
                alt21=2;
                }
                break;
            case 48:
                {
                alt21=3;
                }
                break;
            case 44:
                {
                alt21=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;
            }

            switch (alt21) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:515:8: ( ID '::' )? t= test p= predicates
                    {
                    // org/objectweb/fractal/fscript/parser/FScript.g:515:8: ( ID '::' )?
                    int alt20=2;
                    switch ( input.LA(1) ) {
                        case ID:
                            {
                            switch ( input.LA(2) ) {
                                case 46:
                                    {
                                    alt20=1;
                                    }
                                    break;
                            }

                            }
                            break;
                    }

                    switch (alt20) {
                        case 1 :
                            // org/objectweb/fractal/fscript/parser/FScript.g:515:9: ID '::'
                            {
                            ID5=(Token)match(input,ID,FOLLOW_ID_in_locationStep1672); 
                            match(input,46,FOLLOW_46_in_locationStep1674); 

                            }
                            break;

                    }

                    pushFollow(FOLLOW_test_in_locationStep1680);
                    t=test();

                    state._fsp--;

                    pushFollow(FOLLOW_predicates_in_locationStep1684);
                    p=predicates();

                    state._fsp--;


                                SourceLocation loc = null;
                    	    String axis = "child";
                                if (ID5 != null) {
                                    axis = (ID5!=null?ID5.getText():null);
                                    loc = sourceExtent(sourceExtent(ID5), t.getSourceLocation());
                                } else {
                                    loc = t.getSourceLocation();
                                }
                                if (!p.isEmpty()) {
                                    loc = sourceExtent(loc, sourceExtent(p));
                                }
                                result = new LocationStep(loc, axis, t, p);
                           

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:533:8: a= '@' t= test p= predicates
                    {
                    a=(Token)match(input,47,FOLLOW_47_in_locationStep1714); 
                    pushFollow(FOLLOW_test_in_locationStep1718);
                    t=test();

                    state._fsp--;

                    pushFollow(FOLLOW_predicates_in_locationStep1722);
                    p=predicates();

                    state._fsp--;


                                SourceLocation loc = sourceExtent(sourceExtent(a), t.getSourceLocation());
                                if (!p.isEmpty()) {
                                    loc = sourceExtent(loc, sourceExtent(p));
                                }
                                result = new LocationStep(loc, "attribute", t, p);
                            

                    }
                    break;
                case 3 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:544:8: a= '..' p= predicates
                    {
                    a=(Token)match(input,48,FOLLOW_48_in_locationStep1753); 
                    pushFollow(FOLLOW_predicates_in_locationStep1757);
                    p=predicates();

                    state._fsp--;


                                SourceLocation loc = sourceExtent(a);
                                if (!p.isEmpty()) {
                                  loc = sourceExtent(loc, sourceExtent(p));
                                }
                                result = new LocationStep(loc, "parent", null, p);
                            

                    }
                    break;
                case 4 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:555:8: a= '/' t= test p= predicates
                    {
                    a=(Token)match(input,44,FOLLOW_44_in_locationStep1788); 
                    pushFollow(FOLLOW_test_in_locationStep1792);
                    t=test();

                    state._fsp--;

                    pushFollow(FOLLOW_predicates_in_locationStep1796);
                    p=predicates();

                    state._fsp--;


                                SourceLocation loc = sourceExtent(sourceExtent(a), t.getSourceLocation());
                                if (!p.isEmpty()) {
                                    loc = sourceExtent(loc, sourceExtent(p));
                                }
                                result = new LocationStep(loc, "descendant-or-self", t, p);
                            

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "locationStep"


    // $ANTLR start "predicates"
    // org/objectweb/fractal/fscript/parser/FScript.g:566:1: predicates returns [ List<ASTNode> result ] : ( '[' pred= expression ']' )* ;
    public final List<ASTNode> predicates() throws RecognitionException {
        List<ASTNode> result = null;

        ASTNode pred = null;



          result = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:573:5: ( ( '[' pred= expression ']' )* )
            // org/objectweb/fractal/fscript/parser/FScript.g:573:9: ( '[' pred= expression ']' )*
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:573:9: ( '[' pred= expression ']' )*
            loop22:
            do {
                int alt22=2;
                switch ( input.LA(1) ) {
                case 49:
                    {
                    alt22=1;
                    }
                    break;

                }

                switch (alt22) {
            	case 1 :
            	    // org/objectweb/fractal/fscript/parser/FScript.g:573:10: '[' pred= expression ']'
            	    {
            	    match(input,49,FOLLOW_49_in_predicates1838); 
            	    pushFollow(FOLLOW_expression_in_predicates1842);
            	    pred=expression();

            	    state._fsp--;

            	     result.add(pred); 
            	    match(input,50,FOLLOW_50_in_predicates1846); 

            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "predicates"


    // $ANTLR start "test"
    // org/objectweb/fractal/fscript/parser/FScript.g:576:1: test returns [ ASTNode result ] : ( ID | s= '*' | v= variable | STRING ) ;
    public final ASTNode test() throws RecognitionException {
        ASTNode result = null;

        Token s=null;
        Token ID6=null;
        Token STRING7=null;
        ASTNode v = null;



          ASTNode nameExpr = null;
          SourceLocation loc = null;

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:594:5: ( ( ID | s= '*' | v= variable | STRING ) )
            // org/objectweb/fractal/fscript/parser/FScript.g:594:9: ( ID | s= '*' | v= variable | STRING )
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:594:9: ( ID | s= '*' | v= variable | STRING )
            int alt23=4;
            switch ( input.LA(1) ) {
            case ID:
                {
                alt23=1;
                }
                break;
            case 39:
                {
                alt23=2;
                }
                break;
            case 45:
                {
                alt23=3;
                }
                break;
            case STRING:
                {
                alt23=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }

            switch (alt23) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:594:11: ID
                    {
                    ID6=(Token)match(input,ID,FOLLOW_ID_in_test1883); 
                     nameExpr = new Constant(sourceExtent(ID6), (ID6!=null?ID6.getText():null)); 

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:595:11: s= '*'
                    {
                    s=(Token)match(input,39,FOLLOW_39_in_test1907); 
                     nameExpr = null; loc= sourceExtent(s); 

                    }
                    break;
                case 3 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:596:11: v= variable
                    {
                    pushFollow(FOLLOW_variable_in_test1928);
                    v=variable();

                    state._fsp--;

                     nameExpr = v; 

                    }
                    break;
                case 4 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:597:11: STRING
                    {
                    STRING7=(Token)match(input,STRING,FOLLOW_STRING_in_test1942); 
                     nameExpr = new Constant(sourceExtent(STRING7), stringValue(STRING7.getText())); 

                    }
                    break;

            }


            }


                if (nameExpr != null) {
                    loc = nameExpr.getSourceLocation();
                    Call currentCall = new Call(loc, "current");
                    Call nameCall = new Call(loc, "name", currentCall);
                    result = new Call(loc, "==", nameCall, nameExpr);
                } else {
                    result = new Constant(loc, true);
                }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "test"


    // $ANTLR start "literal"
    // org/objectweb/fractal/fscript/parser/FScript.g:601:1: literal returns [ ASTNode result ] : ( NUMBER | STRING );
    public final ASTNode literal() throws RecognitionException {
        ASTNode result = null;

        Token NUMBER8=null;
        Token STRING9=null;

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:605:5: ( NUMBER | STRING )
            int alt24=2;
            switch ( input.LA(1) ) {
            case NUMBER:
                {
                alt24=1;
                }
                break;
            case STRING:
                {
                alt24=2;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:605:9: NUMBER
                    {
                    NUMBER8=(Token)match(input,NUMBER,FOLLOW_NUMBER_in_literal1983); 

                                double value = Double.valueOf(NUMBER8.getText());
                                result = new Constant(sourceExtent(NUMBER8), value);
                            

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:610:9: STRING
                    {
                    STRING9=(Token)match(input,STRING,FOLLOW_STRING_in_literal2003); 

                                String value = stringValue(STRING9.getText());
                                result = new Constant(sourceExtent(STRING9), value);
                            

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "literal"


    // $ANTLR start "call"
    // org/objectweb/fractal/fscript/parser/FScript.g:617:1: call returns [ ASTNode result ] : ( ID '(' args= arguments close= ')' | dot= '.' );
    public final ASTNode call() throws RecognitionException {
        ASTNode result = null;

        Token close=null;
        Token dot=null;
        Token ID10=null;
        List<ASTNode> args = null;


        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:621:5: ( ID '(' args= arguments close= ')' | dot= '.' )
            int alt25=2;
            switch ( input.LA(1) ) {
            case ID:
                {
                alt25=1;
                }
                break;
            case 51:
                {
                alt25=2;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:621:9: ID '(' args= arguments close= ')'
                    {
                    ID10=(Token)match(input,ID,FOLLOW_ID_in_call2038); 
                    match(input,16,FOLLOW_16_in_call2040); 
                    pushFollow(FOLLOW_arguments_in_call2044);
                    args=arguments();

                    state._fsp--;

                    close=(Token)match(input,17,FOLLOW_17_in_call2048); 
                     result = new Call(sourceExtent(ID10, close), (ID10!=null?ID10.getText():null), args); 

                    }
                    break;
                case 2 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:622:9: dot= '.'
                    {
                    dot=(Token)match(input,51,FOLLOW_51_in_call2062); 
                     result = new Call(sourceExtent(dot), "current", new ArrayList<ASTNode>()); 

                    }
                    break;

            }
        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "call"


    // $ANTLR start "arguments"
    // org/objectweb/fractal/fscript/parser/FScript.g:625:1: arguments returns [ List<ASTNode> result ] : (e1= expression ( ',' e2= expression )* )? ;
    public final List<ASTNode> arguments() throws RecognitionException {
        List<ASTNode> result = null;

        ASTNode e1 = null;

        ASTNode e2 = null;



          result = new ArrayList<ASTNode>();

        try {
            // org/objectweb/fractal/fscript/parser/FScript.g:632:5: ( (e1= expression ( ',' e2= expression )* )? )
            // org/objectweb/fractal/fscript/parser/FScript.g:632:9: (e1= expression ( ',' e2= expression )* )?
            {
            // org/objectweb/fractal/fscript/parser/FScript.g:632:9: (e1= expression ( ',' e2= expression )* )?
            int alt27=2;
            switch ( input.LA(1) ) {
                case ID:
                case NUMBER:
                case STRING:
                case 16:
                case 38:
                case 45:
                case 51:
                    {
                    alt27=1;
                    }
                    break;
            }

            switch (alt27) {
                case 1 :
                    // org/objectweb/fractal/fscript/parser/FScript.g:632:16: e1= expression ( ',' e2= expression )*
                    {
                    pushFollow(FOLLOW_expression_in_arguments2121);
                    e1=expression();

                    state._fsp--;

                     result.add(e1); 
                    // org/objectweb/fractal/fscript/parser/FScript.g:633:11: ( ',' e2= expression )*
                    loop26:
                    do {
                        int alt26=2;
                        switch ( input.LA(1) ) {
                        case 18:
                            {
                            alt26=1;
                            }
                            break;

                        }

                        switch (alt26) {
                    	case 1 :
                    	    // org/objectweb/fractal/fscript/parser/FScript.g:633:12: ',' e2= expression
                    	    {
                    	    match(input,18,FOLLOW_18_in_arguments2136); 
                    	    pushFollow(FOLLOW_expression_in_arguments2140);
                    	    e2=expression();

                    	    state._fsp--;

                    	     result.add(e2); 

                    	    }
                    	    break;

                    	default :
                    	    break loop26;
                        }
                    } while (true);


                    }
                    break;

            }


            }

        }

          catch (RecognitionException re) {
            throw re;
          }
          catch (RuntimeException re) {
            if (re.getCause() instanceof RecognitionException) {
              // Error sent from the parser wrapped in a RuntimeException
              throw (RecognitionException) re.getCause();
            } else {
              throw re;
            }
          }
        finally {
        }
        return result;
    }
    // $ANTLR end "arguments"

    // Delegated rules


 

    public static final BitSet FOLLOW_definition_in_definitions530 = new BitSet(new long[]{0x000000000000C002L});
    public static final BitSet FOLLOW_14_in_definition575 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_15_in_definition583 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_ID_in_definition588 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_definition590 = new BitSet(new long[]{0x0000000000020040L});
    public static final BitSet FOLLOW_parameters_in_definition594 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_definition596 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_block_in_definition600 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_parameters634 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_18_in_parameters639 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_ID_in_parameters643 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_19_in_block688 = new BitSet(new long[]{0x000820400B2104C0L});
    public static final BitSet FOLLOW_statement_in_block694 = new BitSet(new long[]{0x000820400B3104C0L});
    public static final BitSet FOLLOW_20_in_block703 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_statement744 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_ID_in_statement746 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_statement748 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_statement752 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_statement756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_statement786 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_statement788 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_statement792 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_statement796 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_statement828 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_statement830 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_24_in_statement862 = new BitSet(new long[]{0x00082040008104C0L});
    public static final BitSet FOLLOW_expression_in_statement866 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_statement871 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_25_in_statement903 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_statement905 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_statement909 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_statement911 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_block_in_statement915 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_26_in_statement918 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_block_in_statement922 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_27_in_statement956 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_ID_in_statement958 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_statement960 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_statement964 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_block_in_statement968 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orExpression_in_expression1005 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_andExpression_in_orExpression1047 = new BitSet(new long[]{0x0000000020000002L});
    public static final BitSet FOLLOW_29_in_orExpression1057 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_andExpression_in_orExpression1061 = new BitSet(new long[]{0x0000000020000002L});
    public static final BitSet FOLLOW_compExpression_in_andExpression1106 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_30_in_andExpression1116 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_compExpression_in_andExpression1120 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_addExpression_in_compExpression1157 = new BitSet(new long[]{0x0000001F80000002L});
    public static final BitSet FOLLOW_set_in_compExpression1163 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_addExpression_in_compExpression1179 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multExpression_in_addExpression1220 = new BitSet(new long[]{0x0000006000000002L});
    public static final BitSet FOLLOW_set_in_addExpression1232 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_multExpression_in_addExpression1240 = new BitSet(new long[]{0x0000006000000002L});
    public static final BitSet FOLLOW_unaryExpression_in_multExpression1280 = new BitSet(new long[]{0x0000018000000002L});
    public static final BitSet FOLLOW_set_in_multExpression1292 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_unaryExpression_in_multExpression1300 = new BitSet(new long[]{0x0000018000000002L});
    public static final BitSet FOLLOW_38_in_unaryExpression1340 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_atom_in_unaryExpression1344 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atom_in_unaryExpression1366 = new BitSet(new long[]{0x00000E0000000002L});
    public static final BitSet FOLLOW_set_in_unaryExpression1372 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_atom_in_unaryExpression1382 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal_in_atom1437 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_atom1459 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_atom1463 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_atom1465 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_call_in_atom1489 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_44_in_atom1492 = new BitSet(new long[]{0x0009B0C0000104C0L});
    public static final BitSet FOLLOW_relativePath_in_atom1496 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variable_in_atom1531 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_44_in_atom1534 = new BitSet(new long[]{0x0009B0C0000104C0L});
    public static final BitSet FOLLOW_relativePath_in_atom1538 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_locationStep_in_relativePath1584 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_44_in_relativePath1593 = new BitSet(new long[]{0x0009B0C0000104C0L});
    public static final BitSet FOLLOW_locationStep_in_relativePath1597 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_45_in_variable1629 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_ID_in_variable1631 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_locationStep1672 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_46_in_locationStep1674 = new BitSet(new long[]{0x000820C0000104C0L});
    public static final BitSet FOLLOW_test_in_locationStep1680 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_predicates_in_locationStep1684 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_47_in_locationStep1714 = new BitSet(new long[]{0x000820C0000104C0L});
    public static final BitSet FOLLOW_test_in_locationStep1718 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_predicates_in_locationStep1722 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_48_in_locationStep1753 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_predicates_in_locationStep1757 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_44_in_locationStep1788 = new BitSet(new long[]{0x000820C0000104C0L});
    public static final BitSet FOLLOW_test_in_locationStep1792 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_predicates_in_locationStep1796 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_49_in_predicates1838 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_predicates1842 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_50_in_predicates1846 = new BitSet(new long[]{0x0002000000000002L});
    public static final BitSet FOLLOW_ID_in_test1883 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_39_in_test1907 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variable_in_test1928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_test1942 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_in_literal1983 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_literal2003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_call2038 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_call2040 = new BitSet(new long[]{0x00082040000304C0L});
    public static final BitSet FOLLOW_arguments_in_call2044 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_call2048 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_51_in_call2062 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_arguments2121 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_18_in_arguments2136 = new BitSet(new long[]{0x00082040000104C0L});
    public static final BitSet FOLLOW_expression_in_arguments2140 = new BitSet(new long[]{0x0000000000040002L});

}